# OpenSSL Cipher Property
[OpenSSL wrapper]

## Typedefs
typedef struct openssl_cipher_property_t | openssl_cipher_property_t
## Functions
EVP_CIPHER * | openssl_cipher_property_get_cipher (const openssl_cipher_property_t *cprop, const axutil_env_t *env)
axis2_char_t * | openssl_cipher_property_get_name (const openssl_cipher_property_t *cprop, const axutil_env_t *env)
axis2_char_t * | openssl_cipher_property_get_url (const openssl_cipher_property_t *cprop, const axutil_env_t *env)
int | openssl_cipher_property_get_key_size (const openssl_cipher_property_t *cprop, const axutil_env_t *env)
int | openssl_cipher_property_get_block_size (const openssl_cipher_property_t *cprop, const axutil_env_t *env)
int | openssl_cipher_property_get_iv_size (const openssl_cipher_property_t *cprop, const axutil_env_t *env)
axis2_status_t | openssl_cipher_property_set_cipher (openssl_cipher_property_t *cprop, const axutil_env_t *env, EVP_CIPHER *cipher)
axis2_status_t | openssl_cipher_property_set_name (openssl_cipher_property_t *cprop, const axutil_env_t *env, axis2_char_t *name)
axis2_status_t | openssl_cipher_property_set_url (openssl_cipher_property_t *cprop, const axutil_env_t *env, axis2_char_t *url)
axis2_status_t | openssl_cipher_property_set_key_size (openssl_cipher_property_t *cprop, const axutil_env_t *env, int key_size)
axis2_status_t | openssl_cipher_property_set_block_size (openssl_cipher_property_t *cprop, const axutil_env_t *env, int block_size)
axis2_status_t | openssl_cipher_property_set_iv_size (openssl_cipher_property_t *cprop, const axutil_env_t *env, int iv_size)
axis2_status_t | openssl_cipher_property_free (openssl_cipher_property_t *cprop, const axutil_env_t *env)
AXIS2_EXTERN openssl_cipher_property_t * | openssl_cipher_property_create (const axutil_env_t *env)

## Typedef Documentation

typedef struct openssl_cipher_property_t openssl_cipher_property_t

Type name for struct openssl_cipher_property

## Function Documentation

AXIS2_EXTERN openssl_cipher_property_t* openssl_cipher_property_create | ( | const axutil_env_t * | env | ) |

Create a fresh block cipher property

Parameters:

  | env | pointer to environment struct

Returns:
  cipher_prop_ptr

axis2_status_t openssl_cipher_property_free | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Free the cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

int openssl_cipher_property_get_block_size | ( | const openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Given the OpenSSL cipher property returns the cipher block size

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  the block size of the cipher

EVP_CIPHER* openssl_cipher_property_get_cipher | ( | const openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Given the OpenSSL cipher property returns the cipher

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  the cipher

int openssl_cipher_property_get_iv_size | ( | const openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Given the OpenSSL cipher property returns the size of the initial vector

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  the size of the initial vector

int openssl_cipher_property_get_key_size | ( | const openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Given the OpenSSL cipher property returns the size of the key

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  size of the key

axis2_char_t* openssl_cipher_property_get_name | ( | const openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Given the OpenSSL cipher property returns the name of the property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  the name of the cipher property

axis2_char_t* openssl_cipher_property_get_url | ( | const openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env |
| ) |  |  |

Given the OpenSSL cipher property returns the URL Which usually is an algorithm URL

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct

Returns:
  the URL

axis2_status_t openssl_cipher_property_set_block_size | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env,
|  | int | block_size |
| ) |  |  |

Set the size of the cipher block for the OpenSSL cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct
  | block_size | the size of the cipher block

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

axis2_status_t openssl_cipher_property_set_cipher | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env,
|  | EVP_CIPHER * | cipher |
| ) |  |  |

Set the Cipher for the OpenSSL cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct
  | cipher | The cipher to be set in the property

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

axis2_status_t openssl_cipher_property_set_iv_size | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env,
|  | int | iv_size |
| ) |  |  |

Set the size of the initial vector for the OpenSSL cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct
  | iv_size | the size of the initial vector

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

axis2_status_t openssl_cipher_property_set_key_size | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env,
|  | int | key_size |
| ) |  |  |

Set the the size of the key for the OpenSSL cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct
  | key_size | the size of the key

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

axis2_status_t openssl_cipher_property_set_name | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env,
|  | axis2_char_t * | name |
| ) |  |  |

Set the name for the OpenSSL cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct
  | name | of the OpenSSL cipher property

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

axis2_status_t openssl_cipher_property_set_url | ( | openssl_cipher_property_t * | cprop,
|  | const axutil_env_t * | env,
|  | axis2_char_t * | url |
| ) |  |  |

Set the url for the OpenSSL cipher property

Parameters:

  | cprop | The OpenSSL cipher property
  | env | pointer to environment struct
  | url | The URL of the OpenSSL cipher property

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE